/******************************************************************************
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

GNU Lesser General Public License can be read on GNU-LGPL.txt

Copyright (C) 2006 Marc 'aka Froggy' PLANTUREUX and CDRG Prod/CoPHPeeShop
mail at : marc[dot)plantureux{@]cophpeeshop#dot#com
******************************************************************************/

CREATE OR REPLACE FUNCTION create_table() RETURNS integer AS '
DECLARE

BEGIN

drop table "categorie" cascade;
drop sequence id_categorie_seq;

CREATE SEQUENCE id_categorie_seq;
CREATE TABLE "categorie" (
  "id_categorie" int4 DEFAULT nextval(\'id_categorie_seq\') PRIMARY KEY,
  "id_categorie_mere" int4 REFERENCES categorie(id_categorie) MATCH FULL ON DELETE CASCADE NOT NULL,
  "id_categorie_lien" int4 REFERENCES categorie(id_categorie) MATCH FULL ON DELETE CASCADE NOT NULL,
  "visible" boolean DEFAULT false,
  "ordre" int DEFAULT 0,
  "nom0" text NOT NULL,
  "path_id" text,
  "path_nom0" text,
  "niveau"  int
);
CREATE INDEX categorie_id_categorie_mere ON categorie(id_categorie_mere);
CREATE INDEX categorie_path_id ON categorie(path_id);

INSERT INTO categorie (id_categorie, id_categorie_mere, id_categorie_lien, path_id, nom0, path_nom0, niveau) VALUES (\'-1\', \'-1\', \'-1\', \'|-1\', \'Racine\', \'|Racine\', -1);

INSERT INTO categorie (id_categorie, id_categorie_mere, id_categorie_lien, path_id, nom0, path_nom0, niveau) VALUES (0, \'-1\', \'-1\', \'|0\', \'Root\', \'|Root\', 0);
INSERT INTO categorie (id_categorie, id_categorie_mere, id_categorie_lien, path_id, nom0, path_nom0, niveau) VALUES (\'999999999\', \'0\', \'-1\', \'|0|999999999\', \'Poubelle\', \'|Root|Poubelle\', 1);


INSERT INTO categorie (id_categorie, id_categorie_mere, id_categorie_lien, path_id, nom0, path_nom0, niveau) VALUES (\'1\', \'0\', \'-1\', \'|0|1\', \'Cat1\', \'|Root|Cat1\', 1);
INSERT INTO categorie (id_categorie, id_categorie_mere, id_categorie_lien, path_id, nom0, path_nom0, niveau) VALUES (\'11\', \'1\', \'-1\', \'|0|1|11\', \'Cat11\', \'|Root|Cat1|Cat11\', 2);
INSERT INTO categorie (id_categorie, id_categorie_mere, id_categorie_lien, path_id, nom0, path_nom0, niveau) VALUES (\'111\', \'11\', \'-1\', \'|0|1|11|111\', \'Cat111\', \'|Root|Cat1|Cat11|Cat111\', 3);
INSERT INTO categorie (id_categorie, id_categorie_mere, id_categorie_lien, path_id, nom0, path_nom0, niveau) VALUES (\'112\', \'11\', \'-1\', \'|0|1|11|112\', \'Cat112\', \'|Root|Cat1|Cat11|Cat112\', 3);
INSERT INTO categorie (id_categorie, id_categorie_mere, id_categorie_lien, path_id, nom0, path_nom0, niveau) VALUES (\'12\', \'1\', \'-1\', \'|0|1|12\', \'Cat12\', \'|Root|Cat1|Cat12\', 2);
INSERT INTO categorie (id_categorie, id_categorie_mere, id_categorie_lien, path_id, nom0, path_nom0, niveau) VALUES (\'7\', \'1\', \'-1\', \'|0|1|7\', \'Cat7\', \'|Root|Cat1|Cat7\', 2);
INSERT INTO categorie (id_categorie, id_categorie_mere, id_categorie_lien, path_id, nom0, path_nom0, niveau) VALUES (\'40\', \'7\', \'-1\', \'|0|1|7|40\', \'Cat40\', \'|Root|Cat1|Cat7|Cat40\', 3);
INSERT INTO categorie (id_categorie, id_categorie_mere, id_categorie_lien, path_id, nom0, path_nom0, niveau) VALUES (\'202\', \'40\', \'-1\', \'|0|1|7|40|202\', \'Cat202\', \'|Root|Cat1|Cat7|Cat40|Cat202\', 4);
INSERT INTO categorie (id_categorie, id_categorie_mere, id_categorie_lien, path_id, nom0, path_nom0, niveau) VALUES (\'1011\', \'202\', \'-1\', \'|0|1|7|40|202|1011\', \'Cat1011\', \'|Root|Cat1|Cat7|Cat40|Cat202|Cat1011\', 5);
INSERT INTO categorie (id_categorie, id_categorie_mere, id_categorie_lien, path_id, nom0, path_nom0, niveau) VALUES (\'1012\', \'202\', \'-1\', \'|0|1|7|40|202|1012\', \'Cat1012\', \'|Root|Cat1|Cat7|Cat40|Cat202|Cat1012\', 5);
INSERT INTO categorie (id_categorie, id_categorie_mere, id_categorie_lien, path_id, nom0, path_nom0, niveau) VALUES (\'1013\', \'202\', \'-1\', \'|0|1|7|40|202|1013\', \'Cat1013\', \'|Root|Cat1|Cat7|Cat40|Cat202|Cat1013\', 5);
INSERT INTO categorie (id_categorie, id_categorie_mere, id_categorie_lien, path_id, nom0, path_nom0, niveau) VALUES (\'1014\', \'202\', \'-1\', \'|0|1|7|40|202|1014\', \'Cat1014\', \'|Root|Cat1|Cat7|Cat40|Cat202|Cat1014\', 5);
INSERT INTO categorie (id_categorie, id_categorie_mere, id_categorie_lien, path_id, nom0, path_nom0, niveau) VALUES (\'1015\', \'202\', \'-1\', \'|0|1|7|40|202|1015\', \'Cat1015\', \'|Root|Cat1|Cat7|Cat40|Cat202|Cat1015\', 5);

--partie lien
INSERT INTO categorie (id_categorie, id_categorie_mere, id_categorie_lien, path_id, nom0, path_nom0, niveau) VALUES (\'9000\', \'40\', \'11\', \'|0|1|7|40|9000\', \'Cat11\', \'|Root|Cat1|Cat7|Cat40|Cat11\', 4);
INSERT INTO categorie (id_categorie, id_categorie_mere, id_categorie_lien, path_id, nom0, path_nom0, niveau) VALUES (\'9001\', \'9000\', \'111\', \'|0|1|7|40|9000|9001\', \'Cat111\', \'|Root|Cat1|Cat7|Cat40|Cat11|Cat111\', 5);
INSERT INTO categorie (id_categorie, id_categorie_mere, id_categorie_lien, path_id, nom0, path_nom0, niveau) VALUES (\'9002\', \'9000\', \'112\', \'|0|1|7|40|9000|9002\', \'Cat112\', \'|Root|Cat1|Cat7|Cat40|Cat11|Cat112\', 5);



ALTER SEQUENCE id_categorie_seq RESTART WITH 10000;



return 0;

END;
' LANGUAGE plpgsql;

SELECT create_table();