/******************************************************************************
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

GNU Lesser General Public License can be read on GNU-LGPL.txt

Copyright (C) 2006 Marc 'aka Froggy' PLANTUREUX and CDRG Prod/CoPHPeeShop
mail at : marc[dot)plantureux{@]cophpeeshop#dot#com
******************************************************************************/

CREATE OR REPLACE FUNCTION categorie_before_delete() RETURNS trigger AS '
	DECLARE
		categorie_arbre RECORD;
		categorie_lien_arbre RECORD;
		a INT4;
		tmp text;

BEGIN
--on interdit le delete des categories primaires
	IF OLD.id_categorie = 999999999 OR OLD.id_categorie = 0 OR OLD.id_categorie = -1 THEN
		RAISE EXCEPTION ''On ne peut pas delete la poubelle, le root et la categorie -1'';
	END IF;

--on regarde si la categorie est deja dans la poubelle
	IF strpos(OLD.path_id, \'999999999\') <> 0 THEN
		--oui, on vire toutes l arborescence
		DELETE FROM categorie WHERE path_id LIKE \'%|\' || OLD.id_categorie || \'|%\';
	ELSE

		--non, on regarde si il y a une categorie de lien dans le path
		FOR categorie_arbre IN SELECT categorie.id_categorie, categorie.id_categorie_lien, categorie.path_id FROM categorie WHERE categorie.path_id LIKE \'%|\' || OLD.id_categorie || \'|%\' LOOP

			--on regarde si c est une categorie lien
			IF categorie_arbre.id_categorie_lien = -1 THEN
				--si ce n ai pas une categori lien, on update vers la poubelle
				a := strpos(OLD.path_id, OLD.id_categorie);
				tmp := substr(categorie_arbre.path_id, a);
				UPDATE categorie SET path_id = \'|0|999999999|\' || tmp WHERE id_categorie = categorie_arbre.id_categorie;

				--on detruit les categories liens inherentes				
				DELETE FROM categorie WHERE id_categorie_lien = categorie_arbre.id_categorie;
			END IF;
		END LOOP;

		--on gere le cas de la categorie en elle meme
		--on regarde si c est une categorie lien (si c est une categorie lien, le DELETE CASCADE s en occupe)
		IF OLD.id_categorie_lien = -1 THEN
			--si ce n ai pas une categori lien, on update vers la poubelle
			a := strpos(OLD.path_id, OLD.id_categorie);
			tmp := substr(OLD.path_id, a);
			UPDATE categorie SET path_id = \'|0|999999999|\' || tmp, id_categorie_mere = 999999999 WHERE id_categorie = OLD.id_categorie;

			--on detruit les categories liens inherentes				
			DELETE FROM categorie WHERE id_categorie_lien = OLD.id_categorie;
		END IF;


		--on regarde si on est dans le cas ou la categorie detruite a ete mise  la poubelle
		IF a > 0 THEN
			RETURN NEW;
		END IF;
	END IF;

	RETURN OLD;
END;
' LANGUAGE plpgsql;

CREATE TRIGGER categorie_before_delete BEFORE DELETE ON categorie FOR EACH ROW EXECUTE PROCEDURE categorie_before_delete();