/******************************************************************************
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

GNU Lesser General Public License can be read on GNU-LGPL.txt

Copyright (C) 2006 Marc 'aka Froggy' PLANTUREUX and CDRG Prod/CoPHPeeShop
mail at : marc[dot)plantureux{@]cophpeeshop#dot#com
******************************************************************************/

CREATE OR REPLACE FUNCTION categorie_before_insert() RETURNS trigger AS '
	DECLARE
		categorie_mere RECORD;
		categorie_mere_lien RECORD;
		categorie_lien RECORD;
	BEGIN

--on remet en forme la nouvelle categorie a inserer
--after_update s occupe de la remise en forme

--on recupere les infos de la categorie mere
SELECT INTO categorie_mere * FROM categorie WHERE categorie.id_categorie = NEW.id_categorie_mere;

	IF NEW.id_categorie_lien = -1 THEN	--la nouvelle categorie n a pas de lien ce n ai pas un lien symbolique

		IF categorie_mere.id_categorie_lien <> -1 THEN	--la categorie mere est un lien
								--on rajoute la nouvelle categorie a la racine du lien
--			SELECT INTO categorie_mere_lien * FROM categorie WHERE id_categorie = categorie_mere.id_categorie_lien;
--			categorie_mere := categorie_mere_lien;
			SELECT INTO categorie_mere * FROM categorie WHERE categorie.id_categorie = categorie_mere.id_categorie_lien;
			NEW.id_categorie_mere = categorie_mere.id_categorie;
		END IF;


	ELSE  --la nouvelle categorie pointe sur une autre categorie
		
		--on regarde si le lien est deja un lien
		SELECT INTO categorie_lien * FROM categorie WHERE categorie.id_categorie = NEW.id_categorie_lien;
		
		IF categorie_lien.id_categorie_lien <> -1 THEN	--on fait pointer le lien vers la racine du lien

			NEW.id_categorie_lien := categorie_lien.id_categorie_lien;

		--ELSE
		--	IF categorie_mere.id_categorie_lien <> -1 THEN	--cat mere est un lien
--
--				SELECT INTO categorie_mere * FROM categorie WHERE categorie.id_categorie = categorie_mere.id_categorie_lien;
--
--			END IF;
		END IF;

	END IF;

	NEW.path_id := categorie_mere.path_id || ''|'' || NEW.id_categorie;
	NEW.path_nom0 := categorie_mere.path_nom0 || ''|'' || NEW.nom0;

	--on update le niveau
	NEW.niveau := strOccurence (NEW.path_id, \'|\');

	RETURN NEW;
    
END;
' LANGUAGE plpgsql;

CREATE TRIGGER categorie_before_insert BEFORE INSERT ON categorie FOR EACH ROW EXECUTE PROCEDURE categorie_before_insert();














































CREATE OR REPLACE FUNCTION categorie_after_insert() RETURNS trigger AS '
	DECLARE
		categorie_mere RECORD;	--definit la categorie mere de la categorie NEW
		categorie_mere_lien RECORD;	--definit l
		categorie_lien RECORD;	--definit les liens sur la categorie mere de la categorie NEW
		categorie_tmp RECORD;
		a INTEGER;
		--b INTEGER;
		tmp text;
	BEGIN

--on remet en forme l architecture de categorie en fonction du nouveau insert

--on recup les infos de la categorie mere
SELECT INTO categorie_mere * FROM categorie WHERE categorie.id_categorie = NEW.id_categorie_mere;

	IF NEW.id_categorie_lien = -1 THEN	--la nouvelle categorie n ai pas un lien
		--pour chaque categorie dont la categorie_mere est en lien, on rajoute la nouvelle categorie
		FOR categorie_lien IN SELECT * FROM categorie WHERE categorie.id_categorie_lien = categorie_mere.id_categorie ORDER BY path_id LOOP

			INSERT INTO categorie (nom0, id_categorie_mere, id_categorie_lien, visible, ordre) VALUES (NEW.nom0, categorie_lien.id_categorie, NEW.id_categorie, NEW.visible, NEW.ordre);

		END LOOP;

	ELSE	--la nouvelle categorie ai un lien
		IF categorie_mere.id_categorie_lien <> -1 THEN
			RAISE NOTICE ''Ajout d un lien dans un lien non gr.'';	--anciencement RAISE EXCEPTION
		END IF;

		--on recupere les categories associes a NEW.id_categorie_lien
		FOR categorie_lien IN SELECT * FROM categorie WHERE categorie.path_id LIKE \'%|\' || NEW.id_categorie_lien || \'|%\' ORDER BY path_id LOOP

			--on ne garde que les categories directement lie a notre categorie lien, la recursivite s occupe du reste
			a := strpos(categorie_lien.path_id, NEW.id_categorie_lien);
			tmp := substr(categorie_lien.path_id, a);

			a := strpos (tmp, ''|'');
			IF a <> 0 THEN

				tmp := substr(tmp, a + 1);
				a := strpos (tmp, ''|'');

				IF a = 0 THEN	--on a une categorie directement lie a la categorie lien, on rajoute la categorie
				
					INSERT INTO categorie (nom0, id_categorie_mere, id_categorie_lien, visible, ordre) VALUES (categorie_lien.nom0, NEW.id_categorie, categorie_lien.id_categorie, categorie_lien.visible, categorie_lien.ordre);

				END IF;

			END IF;

		END LOOP;
	END IF;


	RETURN NEW;
    
END;
' LANGUAGE plpgsql;

CREATE TRIGGER categorie_after_insert AFTER INSERT ON categorie FOR EACH ROW EXECUTE PROCEDURE categorie_after_insert();