/******************************************************************************
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

GNU Lesser General Public License can be read on GNU-LGPL.txt

Copyright (C) 2006 Marc 'aka Froggy' PLANTUREUX and CDRG Prod/CoPHPeeShop
mail at : marc[dot)plantureux{@]cophpeeshop#dot#com
******************************************************************************/

CREATE OR REPLACE FUNCTION categorie_before_update() RETURNS trigger AS '
	DECLARE
		categorie_tmp RECORD;
		categorie_mere RECORD;
		categorie_primaire RECORD;
	BEGIN

/*

ON FAIT LA GESTION D ERREUR

*/
SELECT INTO categorie_mere * FROM categorie WHERE id_categorie = NEW.id_categorie_mere;

--on interdit la modification du flag id_categorie_lien
IF NEW.id_categorie_lien <> OLD.id_categorie_lien THEN
	RAISE EXCEPTION ''La modification de id_categorie_lien n ai pas possible'';
END IF;

--on interdit les deplacements de categorie sur elle meme
IF strpos(categorie_mere.path_id, \'|\' || new.id_categorie || \'|\') THEN
	RAISE EXCEPTION ''Deplacement d une categorie dans son propre arbre n ai pas possible'';
END IF;

/*

ON FAIT L UPDATE

*/

--on fait une modification du nom
IF NEW.nom0 <> OLD.nom0 THEN
		--GESTION DU CAS OU ON CHANGE LE NOM D UNE CATEGORIE AVEC DEUX FOIS LE MEME NOM DE CATEGORIE DANS LE PATH.
		IF strOccurence(OLD.path_nom0, \'|\' || OLD.nom0 || \'|\') > 1 THEN
			RAISE NOTICE ''Prsence de deux fois le meme nom dans le path. Erreur possible.'';
		END IF;

		NEW.path_nom0 = replace(OLD.path_nom0, \'|\' || OLD.nom0 || \'|\', NEW.nom0);
		NEW.path_nom0 = replace(OLD.path_nom0, \'|\' || OLD.nom0, \'|\' || NEW.nom0);
END IF;

--on fait un deplacement dans l arbre
IF NEW.id_categorie_mere <> OLD.id_categorie_mere THEN
	SELECT INTO categorie_mere * FROM categorie WHERE id_categorie = NEW.id_categorie_mere;

	IF categorie_mere.id_categorie_lien <> -1 AND NEW.id_categorie_lien = -1 THEN
	--si c est un lien, on deplace  la categorie vers la categorie_mere de la categorie pointe par le lien
		NEW.id_categorie_mere = categorie_mere.id_categorie_lien;
		--on recharge categorie_mere
		SELECT INTO categorie_mere * FROM categorie WHERE id_categorie = NEW.id_categorie_mere;
	END IF;

	
	IF categorie_mere.id_categorie_lien = -1 THEN
	-- on regarde si la nouvelle categorie_mere est un lien	
		--on modifie le path_id pour la categorie en cours d update
		NEW.path_id := categorie_mere.path_id || \'|\' || NEW.id_categorie;

		--on modifie le path_nom0 pour la categorie en cours d update
		NEW.path_nom0 := categorie_mere.path_nom0 || \'|\' || NEW.nom0;
	END IF;
END IF;

	--on update le niveau
	NEW.niveau := strOccurence (NEW.path_id, \'|\');

	RETURN NEW;
    
END;
' LANGUAGE plpgsql;

CREATE TRIGGER categorie_before_update BEFORE UPDATE ON categorie FOR EACH ROW EXECUTE PROCEDURE categorie_before_update();





























CREATE OR REPLACE FUNCTION categorie_after_update() RETURNS trigger AS '
	DECLARE
		categorie_primaire RECORD;
		categorie_tmp RECORD;
		categorie_mere RECORD;
		categorie_lien_sur_categorie_mere RECORD;
		new_path_id TEXT;
		new_path_nom0 TEXT;
		a INTEGER;
		tmp TEXT;
	BEGIN

--on fait une modification du nom :
IF NEW.nom0 <> OLD.nom0 THEN
	--on modifie pour l arbre direct	
	FOR categorie_tmp IN SELECT * FROM categorie WHERE categorie.path_id LIKE \'%|\' || OLD.id_categorie || \'|%\' ORDER BY path_id LOOP	
		--GESTION DU CAS OU ON CHANGE LE NOM D UNE CATEGORIE AVEC DEUX FOIS LE MEME NOM DE CATEGORIE DANS LE PATH.
		IF strOccurence(OLD.path_nom0, \'|\' || OLD.nom0 || \'|\') > 1 THEN
			RAISE NOTICE ''Prsence de deux fois le meme nom dans le path. Erreur possible.'';
		END IF;
		
		
		UPDATE categorie SET path_nom0 = replace(categorie_tmp.path_nom0, \'|\' || OLD.nom0 || \'|\', \'|\' || NEW.nom0 || \'|\') WHERE id_categorie = categorie_tmp.id_categorie;
	END LOOP;

	--on modifie le nom des liens sur la categorie
	--l auto appel s occupe de modif l arbre des liens
	--on verifie que ce n ai pas une categorie lien
	IF NEW.id_categorie_lien = -1 THEN
		FOR categorie_tmp IN SELECT * FROM categorie WHERE categorie.id_categorie_lien = NEW.id_categorie LOOP
			UPDATE categorie SET nom0 = NEW.nom0 WHERE categorie.id_categorie = categorie_tmp.id_categorie;
		END LOOP;
	--si c est une categorie lien, on update juste la categorie primaire
	ELSE
		UPDATE categorie SET nom0 = NEW.nom0 WHERE id_categorie = NEW.id_categorie_lien;
	END IF;
END IF;

--on fait un deplacement dans l arbre
IF NEW.id_categorie_mere <> OLD.id_categorie_mere THEN
	SELECT INTO categorie_mere * FROM categorie WHERE id_categorie = NEW.id_categorie_mere;

	SELECT INTO categorie_lien_sur_categorie_mere * FROM categorie WHERE id_categorie_lien = categorie_mere.id_categorie;

	IF categorie_mere.id_categorie_lien = -1 THEN

		IF NEW.id_categorie_lien <> -1 THEN
	/*			--alors, on deplace la categorie vers la categorie primaire pointe par le lien de la categorie_mere
			--le trigger d update s occupe de reconstruire l arbre
			NEW.id_categorie_mere = categorie_mere.id_categorie_lien;
		ELSE*/
			IF categorie_lien_sur_categorie_mere.id_categorie IS NOT NULL THEN
			--la categorie mere n a pas de lien pointant sur elle, on deplace juste l arbre de lien
				--on recupere l a categorie primaire de la categorie_lien qu on deplace
				--on la deplace a la racine de la categorie primaire de la categorie_mere
				UPDATE categorie SET id_categorie_mere = categorie_mere.id_categorie_lien WHERE id_categorie = NEW.id_categorie_lien;
				--on rajoute un arbre de lien a la place de l ancienne position de la categorie primaire
				SELECT INTO categorie_primaire * FROM categorie WHERE id_categorie = NEW.id_categorie_lien;
				INSERT INTO categorie (id_categorie_lien, id_categorie_mere, visible, ordre, nom0) VALUES (categorie_primaire.id_categorie, categorie_primaire.id_categorie_mere, categorie_primaire.visible, categorie_primaire.ordre, categorie_primaire.nom0);		
			END IF;
		END IF;

	END IF;

	--on regarde si la categorie mere a des liens pointant sur elle, si oui, on recree l arbre
	--si categorie_mere a des liens pointants sur elle, c est forcement une categorie primaire
	FOR categorie_lien_sur_categorie_mere IN SELECT * FROM categorie WHERE categorie.id_categorie_lien = NEW.id_categorie_mere LOOP
		INSERT INTO categorie (id_categorie_lien, id_categorie_mere, visible, ordre, nom0) VALUES (NEW.id_categorie, categorie_lien_sur_categorie_mere.id_categorie, NEW.visible, NEW.ordre, NEW.nom0);
	END LOOP;

	--on modifie le path_id et path_nom0 pour le lien et tous les liens
	--on modifie le path_id et path_nom0 pour toutes les categories dependantes
	FOR categorie_tmp IN SELECT * FROM categorie WHERE path_id like \'%|\' || NEW.id_categorie || \'|%\' LOOP

		a := strpos(categorie_tmp.path_id, \'|\' || NEW.id_categorie || \'|\');
		tmp := substr(categorie_tmp.path_id, a + 1, char_length(categorie_tmp.path_id));
		a := strpos(tmp, \'|\');
		tmp := substr(tmp, a + 1, char_length(tmp));	--on a l arbo de la categorie sans le reste

		UPDATE categorie SET path_id = NEW.path_id || \'|\' || tmp WHERE categorie.id_categorie = categorie_tmp.id_categorie;

		a := strpos(categorie_tmp.path_nom0, \'|\' || NEW.nom0 || \'|\');
		tmp := substr(categorie_tmp.path_nom0, a + 1, char_length(categorie_tmp.path_nom0));
		a := strpos(tmp, \'|\');
		tmp := substr(tmp, a + 1, char_length(tmp));	--on a l arbo de la categorie sans le reste

		UPDATE categorie SET path_nom0 = NEW.path_nom0  || \'|\' || tmp WHERE categorie.id_categorie = categorie_tmp.id_categorie;

	END LOOP;

END IF;

	RETURN NEW;
    
END;
' LANGUAGE plpgsql;

CREATE TRIGGER categorie_after_update AFTER UPDATE ON categorie FOR EACH ROW EXECUTE PROCEDURE categorie_after_update();